﻿using System;
using System.ServiceModel.Channels;
using System.ServiceModel.Configuration;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;

namespace IncomesRegisterSignatureSample
{
    /// <summary>
    /// DigitalSignatureEndpointBehavior enables DigitalSignatureMessageInspector which adds the required digital signature to the SOAP payload.     
    /// </summary>
    public class DigitalSignatureEndpointBehavior : BehaviorExtensionElement, IEndpointBehavior
    {        
        public override Type BehaviorType
        {
            get
            {
                return typeof(DigitalSignatureEndpointBehavior);
            }
        }

        protected override object CreateBehavior()
        {
            return new DigitalSignatureEndpointBehavior();
        }

        public void Validate(ServiceEndpoint endpoint) {}

        public void AddBindingParameters(ServiceEndpoint endpoint, BindingParameterCollection bindingParameters) {}

        public void ApplyDispatchBehavior(ServiceEndpoint endpoint, EndpointDispatcher endpointDispatcher) { }

        public void ApplyClientBehavior(ServiceEndpoint endpoint, ClientRuntime clientRuntime)
        {
            clientRuntime.MessageInspectors.Add(new DigitalSignatureMessageInspector());
        }        
    }

}
